/************************************************************************************/
/*  Program name CAPPOEXT_REQUISITION_HEADER.sql                                              */
/*  Creater:  Kenny, Leung (PCCW - UniHub)                                         */
/*************   History   *************************                                */
/* 16 Jan 2006, Kenny Leung         First created                               */
/************************************************************************************/

set doc off;      
set verify off;
set serveroutput on size 1000000;
whenever sqlerror exit failure rollback;s
alter session set nls_date_format='YYYYMMDD HH24:MI:SS';

DECLARE
	lv_Prog_ID		VARCHAR2(100)	:=	'CAPPOEXT_REQUISITION_HEADER';

	lv_Scc_Count	NUMBER	:=	0;
	lv_Err_Count	NUMBER	:=	0;
	lv_Err_Msg		VARCHAR2(500)	:=	'No Error';

	lv_FileName		VARCHAR2(100)	:=	'CAPPO_REQUISITION_HEADER.dat';
	lv_PathName		VARCHAR2(100)	:=	'/tmp';
	lv_UTL_File		UTL_FILE.File_Type;

	lv_NGO_Name		VARCHAR2(100);
	lv_NGO_Count	NUMBER;

	CURSOR Cur_F(p_NGO VARCHAR2) IS
	SELECT
		PHA.*
	FROM
		PO_REQUISITION_HEADERS_ALL		PHA,
		HR_ALL_ORGANIZATION_UNITS	HRO
	WHERE	PHA.ORG_ID	=	HRO.ORGANIZATION_ID
	AND		SUBSTR(HRO.NAME,4,4)	=	p_NGO;

BEGIN
	lv_NGO_Name		:=	SUBSTR(UPPER('&1'), -4);
	
	SELECT	COUNT('A')
	INTO	lv_NGO_Count
	FROM	HR_ALL_ORGANIZATION_UNITS
	WHERE	SUBSTR(Name,4,4)	=	lv_NGO_Name;

	IF	lv_NGO_Count	>=	1	THEN
        
        lv_UTL_File		:=	UTL_FILE.FOpen(lv_PathName, lv_FileName, 'w');
        
		FOR C1 IN Cur_F(lv_NGO_Name) LOOP
			
			UTL_FILE.PUT_LINE(
                  lv_UTL_File,
                  C1.REQUISITION_HEADER_ID      ||CHR(9)||
                  C1.PREPARER_ID                ||CHR(9)||
                  C1.LAST_UPDATE_DATE           ||CHR(9)||
                  C1.LAST_UPDATED_BY            ||CHR(9)||
                  C1.SEGMENT1                   ||CHR(9)||
                  C1.SUMMARY_FLAG               ||CHR(9)||
                  C1.ENABLED_FLAG               ||CHR(9)||
                  C1.SEGMENT2                   ||CHR(9)||
                  C1.SEGMENT3                   ||CHR(9)||
                  C1.SEGMENT4                   ||CHR(9)||
                  C1.SEGMENT5                   ||CHR(9)||
                  C1.START_DATE_ACTIVE          ||CHR(9)||
                  C1.END_DATE_ACTIVE            ||CHR(9)||
                  C1.LAST_UPDATE_LOGIN          ||CHR(9)||
                  C1.CREATION_DATE              ||CHR(9)||
                  C1.CREATED_BY                 ||CHR(9)||
                  C1.DESCRIPTION                ||CHR(9)||
                  C1.AUTHORIZATION_STATUS       ||CHR(9)||
                  C1.NOTE_TO_AUTHORIZER         ||CHR(9)||
                  C1.TYPE_LOOKUP_CODE           ||CHR(9)||
                  C1.TRANSFERRED_TO_OE_FLAG     ||CHR(9)||
                  C1.ATTRIBUTE_CATEGORY         ||CHR(9)||
                  C1.ATTRIBUTE1                 ||CHR(9)||
                  C1.ATTRIBUTE2                 ||CHR(9)||
                  C1.ATTRIBUTE3                 ||CHR(9)||
                  C1.ATTRIBUTE4                 ||CHR(9)||
                  C1.ATTRIBUTE5                 ||CHR(9)||
                  C1.ON_LINE_FLAG               ||CHR(9)||
                  C1.PRELIMINARY_RESEARCH_FLAG  ||CHR(9)||
                  C1.RESEARCH_COMPLETE_FLAG     ||CHR(9)||
                  C1.PREPARER_FINISHED_FLAG     ||CHR(9)||
                  C1.PREPARER_FINISHED_DATE     ||CHR(9)||
                  C1.AGENT_RETURN_FLAG          ||CHR(9)||
                  C1.AGENT_RETURN_NOTE          ||CHR(9)||
                  C1.CANCEL_FLAG                ||CHR(9)||
                  C1.ATTRIBUTE6                 ||CHR(9)||
                  C1.ATTRIBUTE7                 ||CHR(9)||
                  C1.ATTRIBUTE8                 ||CHR(9)||
                  C1.ATTRIBUTE9                 ||CHR(9)||
                  C1.ATTRIBUTE10                ||CHR(9)||
                  C1.ATTRIBUTE11                ||CHR(9)||
                  C1.ATTRIBUTE12                ||CHR(9)||
                  C1.ATTRIBUTE13                ||CHR(9)||
                  C1.ATTRIBUTE14                ||CHR(9)||
                  C1.ATTRIBUTE15                ||CHR(9)||
                  C1.USSGL_TRANSACTION_CODE     ||CHR(9)||
                  C1.GOVERNMENT_CONTEXT         ||CHR(9)||
                  C1.REQUEST_ID                 ||CHR(9)||
                  C1.PROGRAM_APPLICATION_ID     ||CHR(9)||
                  C1.PROGRAM_ID                 ||CHR(9)||
                  C1.PROGRAM_UPDATE_DATE        ||CHR(9)||
                  C1.INTERFACE_SOURCE_CODE      ||CHR(9)||
                  C1.INTERFACE_SOURCE_LINE_ID   ||CHR(9)||
                  C1.CLOSED_CODE                ||CHR(9)||
                  C1.ORG_ID                     ||CHR(9)||
                  C1.WF_ITEM_TYPE               ||CHR(9)||
                  C1.WF_ITEM_KEY                ||CHR(9)||
                  C1.EMERGENCY_PO_NUM           ||CHR(9)||
                  C1.PCARD_ID                   ||CHR(9)||
                  C1.APPS_SOURCE_CODE           ||CHR(9)||
                  C1.CBC_ACCOUNTING_DATE        ||CHR(9)||
                  C1.CHANGE_PENDING_FLAG        
			);

			lv_Scc_Count	:=	lv_Scc_Count	+	1;
		END LOOP;
		UTL_FILE.FClose(lv_UTL_File);
	ELSE
		lv_Err_Count	:=	lv_Err_Count + 1;
		lv_Err_Msg		:=	lv_NGO_Name||': No PO Requisition headers for NGO'; /*Change it for proper error message*/
	END IF;

	INSERT INTO CAPCNV_LOG(
		PROG_ID,
		PROCESS_DATE,
		RECORD_PROCESSED,
		RECORD_REJECTED,
		RECORD_EXTRACTED,
		ERR_MSG
	) VALUES (
		lv_Prog_ID,
		SYSDATE,
		lv_Scc_Count,
		lv_Err_Count,
		lv_Scc_Count-lv_Err_Count,
		lv_Err_Msg
	);

	COMMIT;
END;
/

